LeetCode_贪心算法_中等_134. 加油站

x33g5p2x  于2022-06-24 转载在 其他  
字(1.5k)|赞(0)|评价(0)|浏览(172)

1.题目

在一条环路上有 n 个加油站,其中第 i 个加油站有汽油 gas[i] 升。

你有一辆油箱容量无限的的汽车,从第 i 个加油站开往第 i + 1 个加油站需要消耗汽油 cost[i] 升。你从其中的一个加油站出发,开始时油箱为空。

给定两个整数数组 gas 和 cost ,如果你可以绕环路行驶一周,则返回出发时加油站的编号,否则返回 -1 。如果存在解,则保证它是 唯一 的。

示例 1:

输入: gas = [1,2,3,4,5], cost = [3,4,5,1,2]
输出: 3
解释:
从 3 号加油站(索引为 3 处)出发,可获得 4 升汽油。此时油箱有 = 0 + 4 = 4 升汽油
开往 4 号加油站,此时油箱有 4 - 1 + 5 = 8 升汽油
开往 0 号加油站,此时油箱有 8 - 2 + 1 = 7 升汽油
开往 1 号加油站,此时油箱有 7 - 3 + 2 = 6 升汽油
开往 2 号加油站,此时油箱有 6 - 4 + 3 = 5 升汽油
开往 3 号加油站,你需要消耗 5 升汽油,正好足够你返回到 3 号加油站。
因此,3 可为起始索引。

示例 2:

输入: gas = [2,3,4], cost = [3,4,3]
输出: -1
解释:
你不能从 0 号或 1 号加油站出发,因为没有足够的汽油可以让你行驶到下一个加油站。
我们从 2 号加油站出发,可以获得 4 升汽油。 此时油箱有 = 0 + 4 = 4 升汽油
开往 0 号加油站,此时油箱有 4 - 3 + 2 = 3 升汽油
开往 1 号加油站,此时油箱有 3 - 3 + 3 = 3 升汽油
你无法返回 2 号加油站,因为返程需要消耗 4 升汽油,但是你的油箱只有 3 升汽油。
因此,无论怎样,你都不可能绕环路行驶一周。

提示:
gas.length == n
cost.length == n
1 <= n <= 105
0 <= gas[i], cost[i] <= 104

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/gas-station

2.思路

(1)贪心

(2)折线图
思路参考该LeetCode用户

3.代码实现(Java)

//思路1————贪心
class Solution {
    public int canCompleteCircuit(int[] gas, int[] cost) {
        //加油站数量
        int cnt = gas.length;
        int staNum = 0;
        while (staNum < cnt) {
            //总共加的油
            int totalGas = 0; 
            //总共消费的油
            int totalCost = 0;
            //记录能走过的加油站数量
            int count = 0;     
            while (count < cnt) {  
                int j = (staNum + count) % cnt; 
                totalGas += gas[j];
                totalCost += cost[j];
                if (totalCost > totalGas) {
                    break;
                }
                count++;
            }
            //如果可以绕环路行驶一周
            if (count == cnt) {
                return staNum;
            } else {
                //否则从下一个站点开始检查
                staNum += count + 1;
            }
        }
        return -1;
    }
}
//思路2————折线图
class Solution {
    public int canCompleteCircuit(int[] gas, int[] cost) {
        //加油站数量
        int cnt = gas.length;
        int restGas = 0;
        int minRestGas = Integer.MAX_VALUE;
        //出发时加油站的编号
        int staNum = 0;
        for (int i = 0; i < cnt; i++) {
            restGas += gas[i] - cost[i];
            if (restGas < minRestGas) {
                minRestGas = restGas;
                staNum = i;
            }
        }
        return restGas < 0 ? -1 : (staNum + 1) % cnt;
    }
}

相关文章

微信公众号

最新文章

更多